import { World, useDeltaTime } from "@rbxts/matter"
import { Lifetime } from "ReplicatedStorage/ecs/components"

/**
 * @todo
 */
function updateIdAttribute(world: World): void {
	for (const [id, lifetime] of world.query(Lifetime)) {
		const newLifetime = lifetime.patch({ elapsed: lifetime.elapsed + useDeltaTime() })

        if (os.clock() > lifetime.spawnedAt + lifetime.length) {
            world.despawn(id)
        } else {
            world.insert(id, newLifetime)
        }
	}
}

export = updateIdAttribute